# Set this flag to build with reduced dependency set
%bcond_with jp_minimal

Name:          jersey
Version:       2.28
Release:       4%{?dist}
Summary:       JAX-RS (JSR 311) production quality Reference Implementation
# Some files in core-server are under ASL 2.0 license
License:       (EPL-2.0 or GPLv2 with exceptions) and ASL 2.0
URL:           https://github.com/eclipse-ee4j/jersey
Source0:       https://github.com/eclipse-ee4j/jersey/archive/%{version}/%{name}-%{version}.tar.gz
Source1:       http://www.apache.org/licenses/LICENSE-2.0.txt

# Support fo servlet 3.1 apis
Patch0:        jersey-2.17-mvc-jsp-servlet31.patch
# Unavailable test dep
Patch1:        0001-Patch-out-dependency-on-JMockit.patch
# Keep working with old deps in Fedora
Patch2:        0002-Port-to-glassfish-jsonp-1.0.patch
Patch3:        0003-Port-to-hibernate-validation-5.x.patch

BuildRequires:  maven-local
BuildRequires:  mvn(com.fasterxml.jackson.core:jackson-annotations)
BuildRequires:  mvn(com.fasterxml.jackson.core:jackson-databind)
BuildRequires:  mvn(com.fasterxml.jackson.module:jackson-module-jaxb-annotations)
BuildRequires:  mvn(com.google.guava:guava:18.0)
BuildRequires:  mvn(com.sun.istack:istack-commons-maven-plugin)
BuildRequires:  mvn(com.sun:tools)
BuildRequires:  mvn(jakarta.ws.rs:jakarta.ws.rs-api)
BuildRequires:  mvn(javax.annotation:javax.annotation-api)
BuildRequires:  mvn(javax.inject:javax.inject)
BuildRequires:  mvn(javax.xml.bind:jaxb-api)
BuildRequires:  mvn(javax.validation:validation-api)
BuildRequires:  mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires:  mvn(org.apache.httpcomponents:httpclient)
BuildRequires:  mvn(org.apache.maven.plugins:maven-enforcer-plugin)
BuildRequires:  mvn(org.codehaus.mojo:build-helper-maven-plugin)
BuildRequires:  mvn(org.eclipse.jetty:jetty-client)
BuildRequires:  mvn(org.glassfish.hk2:hk2-bom:pom:)
BuildRequires:  mvn(org.glassfish.hk2:hk2-locator)
BuildRequires:  mvn(org.glassfish.hk2:osgi-resource-locator)
BuildRequires:  mvn(org.osgi:org.osgi.core)
BuildRequires:  mvn(org.ow2.asm:asm)
BuildRequires:  mvn(xerces:xercesImpl)
%if %{without jp_minimal}
BuildRequires:  mvn(com.github.spullara.mustache.java:compiler)
BuildRequires:  mvn(io.reactivex:rxjava)
BuildRequires:  mvn(javax.el:javax.el-api)
BuildRequires:  mvn(javax.enterprise:cdi-api)
BuildRequires:  mvn(javax.json:javax.json-api)
BuildRequires:  mvn(javax.persistence:persistence-api)
BuildRequires:  mvn(javax.servlet:javax.servlet-api)
BuildRequires:  mvn(javax.servlet.jsp:jsp-api)
BuildRequires:  mvn(javax.servlet:servlet-api)
BuildRequires:  mvn(junit:junit)
BuildRequires:  mvn(org.codehaus.jettison:jettison)
BuildRequires:  mvn(org.eclipse.jetty:jetty-continuation)
BuildRequires:  mvn(org.eclipse.jetty:jetty-server)
BuildRequires:  mvn(org.eclipse.jetty:jetty-util)
BuildRequires:  mvn(org.eclipse.jetty:jetty-webapp)
BuildRequires:  mvn(org.freemarker:freemarker)
BuildRequires:  mvn(org.glassfish.grizzly:grizzly-http-server)
BuildRequires:  mvn(org.glassfish.grizzly:grizzly-http-servlet)
BuildRequires:  mvn(org.glassfish:javax.el)
BuildRequires:  mvn(org.glassfish:javax.json)
BuildRequires:  mvn(org.glassfish:jsonp-jaxrs)
BuildRequires:  mvn(org.hamcrest:hamcrest-library)
BuildRequires:  mvn(org.hibernate:hibernate-validator)
BuildRequires:  mvn(org.hibernate:hibernate-validator-cdi)
BuildRequires:  mvn(org.jboss:jboss-vfs)
BuildRequires:  mvn(org.jboss.spec.javax.interceptor:jboss-interceptors-api_1.2_spec)
BuildRequires:  mvn(org.jboss.spec.javax.transaction:jboss-transaction-api_1.2_spec)
BuildRequires:  mvn(org.jboss.weld.se:weld-se-core)
BuildRequires:  mvn(org.jvnet.mimepull:mimepull)
BuildRequires:  mvn(org.mockito:mockito-all)
BuildRequires:  mvn(org.simpleframework:simple-common)
BuildRequires:  mvn(org.simpleframework:simple-http)
BuildRequires:  mvn(org.simpleframework:simple-transport)
BuildRequires:  mvn(org.testng:testng)
%endif

BuildArch:     noarch

%description
Jersey is the open source JAX-RS (JSR 311)
production quality Reference Implementation
for building RESTful Web services.

%if %{without jp_minimal}
%package test-framework
Summary:       Jersey Test Framework

%description test-framework
%{summary}.
%endif

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n %{name}-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

find . -name "*.jar" -print -delete
find . -name "*.class" -print -delete

# Additional license file
cp -p %{SOURCE1} .
sed -i 's/\r//' LICENSE-2.0.txt

# Remove repackaged bundled deps: guava, objectweb-asm
rm -r core-server/src/main/java/jersey
find core-server -name "*.java" -exec sed -i "s|jersey.repackaged.||" {} +
rm -r core-common/src/main/java/org/glassfish/jersey/internal/guava
grep -rl --include=*.java org.glassfish.jersey.internal.guava | xargs sed -i "s|org\.glassfish\.jersey\.internal\.guava|com.google.common.base|"
find core-* containers/{grizzly2,jdk,jetty}-http media/sse ext/{entity-filtering,bean-validation,rx} -name "*.java" -exec sed -i \
  -e "/base\.Cache/s/common\.base/common.cache/" \
  -e "/base\.LoadingCache/s/common\.base/common.cache/" \
  -e "/base\.Multimap/s/common\.base/common.collect/" \
  -e "/base\.....Multimap/s/common\.base/common.collect/" \
  -e "/base\.HashBasedTable/s/common\.base/common.collect/" \
  -e "/base\.Table/s/common\.base/common.collect/" \
  -e "/base\.ThreadFactoryBuilder/s/common\.base/common.util.concurrent/" \
  -e "/base\.InetAddresses/s/common\.base/common.net/" \
  -e "/base\.Primitives/s/common\.base/common.primitives/" {} +
%pom_add_dep 'com.google.guava:guava:${guava.version}' core-common inject/hk2
%pom_xpath_set "pom:dependency[pom:artifactId = 'guava']/pom:scope" provided containers/jdk-http
%pom_add_dep 'org.ow2.asm:asm:${asm.version}' core-server

# EE4j parent pom contains only release/nexus related stuff, we won't miss it
%pom_remove_parent bom .

# Some Glassfish APIs that moved to the EE4j project are not yet updated in Fedora to
# provide the new Jakarta maven coords, so continue to use the old javax coords for now
%pom_change_dep -r jakarta.servlet:jakarta.servlet-api javax.servlet:javax.servlet-api . test-framework
%pom_change_dep -r jakarta.servlet.jsp:jakarta.servlet.jsp-api javax.servlet.jsp:jsp-api
%pom_change_dep -r jakarta.xml.bind:jakarta.xml.bind-api javax.xml.bind:jaxb-api
%pom_change_dep -r jakarta.annotation:jakarta.annotation-api javax.annotation:javax.annotation-api
%pom_change_dep -r jakarta.persistence:jakarta.persistence-api javax.persistence:persistence-api
%pom_change_dep -r org.glassfish.hk2.external:jakarta.inject javax.inject:javax.inject
%pom_change_dep -r jakarta.el:jakarta.el-api javax.el:javax.el-api
%pom_change_dep -r org.glassfish:jakarta.el org.glassfish:javax.el
%pom_change_dep -r org.glassfish:jakarta.json org.glassfish:javax.json

# Fix NoClassDefFound in tests
%pom_add_dep javax.json:javax.json-api:1.0 media/json-processing

# Fix misc EE API references
%pom_change_dep javax:javaee-api javax.enterprise:cdi-api:'${cdi.api.version}':provided ext/cdi/jersey-cdi1x-transaction
%pom_add_dep org.jboss.spec.javax.transaction:jboss-transaction-api_1.2_spec:1.0.0.Alpha3:provided ext/cdi/jersey-cdi1x-transaction
%pom_add_dep org.jboss.spec.javax.interceptor:jboss-interceptors-api_1.2_spec:1.0.0.Alpha3:provided ext/cdi/jersey-cdi1x-validation

# Fix reference to JDK tools jar
%pom_xpath_remove "pom:dependencies/pom:dependency[pom:artifactId = 'tools']/pom:scope" ext/wadl-doclet
%pom_xpath_remove "pom:dependencies/pom:dependency[pom:artifactId = 'tools']/pom:systemPath" ext/wadl-doclet

# Don't use obsolete servlet API version
%pom_remove_dep -r org.mortbay.jetty:servlet-api-2.5

# JMockit is unavailable in Fedora
%pom_remove_dep -r org.jmockit:jmockit

# Disable plugins/extensions not needed for RPM builds
%pom_xpath_remove pom:build/pom:extensions
%pom_remove_plugin :buildnumber-maven-plugin
%pom_remove_plugin :buildnumber-maven-plugin core-common
%pom_remove_plugin :findbugs-maven-plugin
%pom_remove_plugin :maven-checkstyle-plugin
%pom_remove_plugin :maven-source-plugin
%pom_remove_plugin :maven-jflex-plugin media/moxy
%pom_remove_plugin :maven-jflex-plugin media/jaxb

# Prevent duplicate javadoc invokation
%pom_xpath_remove "pom:plugin[pom:artifactId = 'maven-javadoc-plugin' ]/pom:executions"

# No need to ship archetypes (these are pulled from maven central
# when a user invokes the archetype generator command line tool)
%pom_disable_module archetypes

# Disable incubating projects (not generally production ready)
%pom_disable_module incubator

# Don't ship support for netty that doesn't build
%pom_disable_module netty-http containers
%pom_remove_dep :jersey-container-netty-http bom
%pom_disable_module netty-connector connectors
%pom_remove_dep :jersey-netty-connector bom
%pom_disable_module netty test-framework/providers
%pom_remove_dep :jersey-test-framework-provider-netty test-framework/providers/bundle

# Don't ship support for obsolete Jersey 1.x
%pom_disable_module servlet-portability ext
%pom_remove_dep :jersey-servlet-portability bom

# Don't ship support for obsolete jackson 1.x
%pom_disable_module json-jackson1 media
%pom_remove_dep :jersey-media-json-jackson1 bom

# Requires unavailable dep on eclipse yasson
%pom_disable_module json-binding media
%pom_remove_dep :jersey-media-json-binding bom

# Requires unavailable dep eclipselink moxy
%pom_disable_module moxy media
%pom_remove_dep :jersey-media-moxy bom

# Requires unavailable dep on Spring Framework 4.x
%pom_disable_module spring4 ext
%pom_remove_dep :jersey-spring4 bom

# Requires unavailable dep grizzly-http-client
%pom_disable_module grizzly-connector connectors
%pom_remove_dep :jersey-grizzly-connector bom
%pom_remove_dep org.glassfish.jersey.connectors:jersey-grizzly-connector media/multipart
rm media/multipart/src/test/java/org/glassfish/jersey/media/multipart/internal/MultiPartHeaderModificationTest.java

# Requires unavailable dep ejb-container
%pom_disable_module glassfish containers
%pom_remove_dep :jersey-gf-ejb bom

# Requires unavailable dep on cdi-api 2
%pom_disable_module cdi2-se inject
%pom_remove_dep :jersey-cdi2-se bom

# Requires unavailable dep on rxjava2
%pom_disable_module rx-client-rxjava2 ext/rx
%pom_remove_dep :jersey-rx-client-rxjava2 bom

# Requires unavailable groovy-eclipse-compiler plugin
%pom_disable_module maven test-framework

# Don't bother regenerating wadl sources, we don't have the plugin
%pom_remove_plugin com.sun.tools.xjc.maven2: core-server

# Additional modules to disable when jp_minimal is activated
%if %{with jp_minimal}
%pom_disable_module bom
%pom_disable_module containers
%pom_disable_module security
%pom_disable_module json-jettison media
%pom_disable_module json-processing media
%pom_disable_module multipart media
%pom_disable_module sse media
%pom_disable_module bean-validation ext
%pom_disable_module cdi ext
%pom_disable_module metainf-services ext
%pom_disable_module mvc ext
%pom_disable_module mvc-bean-validation ext
%pom_disable_module mvc-freemarker ext
%pom_disable_module mvc-jsp ext
%pom_disable_module mvc-mustache ext
%pom_disable_module proxy-client ext
%pom_disable_module rx ext
%endif

# Ensure HK2-based InjectionManagerFactory implementation can be discovered under OSGi
%pom_xpath_inject "pom:plugin/pom:configuration/pom:instructions" \
  '<Require-Bundle>org.glassfish.jersey.inject.jersey-hk2;bundle-version="%{version}"</Require-Bundle>' core-common
cp -p inject/hk2/src/main/resources/META-INF/services/org.glassfish.jersey.internal.inject.InjectionManagerFactory \
  core-common/src/main/resources/META-INF/services

# Allow versioned dep on javax.annotation
sed -i -e 's/javax\.annotation\.\*;version="!"/javax.annotation.*/' $(find -name pom.xml)
# Make optional dep on javax.activation
sed -i -e 's/javax\.activation\.\*;/javax.activation.*;resolution:=optional;/' core-common/pom.xml

# All aggregation poms conflict because they have the same aId
%mvn_file "org.glassfish.jersey.connectors:project" %{name}/connectors-project
%mvn_file "org.glassfish.jersey.containers:project" %{name}/containers-project
%mvn_file "org.glassfish.jersey.ext:project" %{name}/ext-project
%mvn_file "org.glassfish.jersey.ext.cdi:project" %{name}/ext-cdi-project
%mvn_file "org.glassfish.jersey.ext.rx:project" %{name}/ext-rx-project
%mvn_file "org.glassfish.jersey.inject:project" %{name}/inject-project
%mvn_file "org.glassfish.jersey.media:project" %{name}/media-project
%mvn_file "org.glassfish.jersey.security:project" %{name}/security-project
%mvn_file "org.glassfish.jersey.test-framework:project" %{name}/test-framework-project
%mvn_file "org.glassfish.jersey.test-framework.providers:project" %{name}/test-framework-providers-project

# Package test framework separately
%mvn_package "org.glassfish.jersey.test-framework*:" test-framework

%build
%if %{without jp_minimal}
# Build everything except examples, integration tests and distribution bundles
%mvn_build -- -PsecurityOff -Dasm.version=6.2.1 -Dmaven.test.failure.ignore=true \
  -Dexamples.excluded -Dtests.excluded -Dbundles.excluded
%else
# Additionally omit tests and testing framework for minimal builds
%mvn_build -f -- -PsecurityOff -Dasm.version=6.2.1 -Dmaven.test.failure.ignore=true \
  -Dexamples.excluded -Dtests.excluded -Dbundles.excluded -Dtest-framework.excluded
%endif

%install
%mvn_install

%files -f .mfiles
%doc README.md CONTRIBUTING.md
%license LICENSE.md NOTICE.md LICENSE-2.0.txt

%if %{without jp_minimal}
%files test-framework -f .mfiles-test-framework
%license LICENSE.md NOTICE.md LICENSE-2.0.txt
%endif

%files javadoc -f .mfiles-javadoc
%license LICENSE.md NOTICE.md LICENSE-2.0.txt

%changelog
* Sun Mar 17 2019 Mat Booth <mat.booth@redhat.com> - 2.28-4
- Make the OSGi dep on javax.activation optional

* Sat Mar 16 2019 Mat Booth <mat.booth@redhat.com> - 2.28-3
- Failure to find InjectionManagerFactory implementation in an OSGi setting

* Sat Mar 16 2019 Mat Booth <mat.booth@redhat.com> - 2.28-2
- Allow versioned dep on javax.annotation (OSGi metadata)

* Fri Mar 08 2019 Mat Booth <mat.booth@redhat.com> - 2.28-1
- Update to latest upstream release
- Don't ship support for obsolete jackson 1.x or jersey 1.x
- Jersey moved to Eclipse EE4j project
- Update license tag CDDL->EPL
- Allow building with a minimal dependency set

* Fri Feb 01 2019 Fedora Release Engineering <releng@fedoraproject.org> - 2.23.2-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.23.2-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Wed Feb 07 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.23.2-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.23.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.23.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Wed Sep 28 2016 gil cattaneo <puntogil@libero.it> 2.23.2-1
- update to 2.23.2

* Wed Aug 24 2016 gil cattaneo <puntogil@libero.it> 2.23.1-4
- jackson 2.7 build fix

* Tue Aug 09 2016 gil cattaneo <puntogil@libero.it> 2.23.1-3
- add missing build requires: xmvn

* Thu Aug 04 2016 gil cattaneo <puntogil@libero.it> 2.23.1-2
- disable test suite

* Wed Jul 27 2016 gil cattaneo <puntogil@libero.it> 2.23.1-1
- update to 2.23.1

* Thu Feb 18 2016 gil cattaneo <puntogil@libero.it> 2.22.2-1
- update to 2.22.2

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 2.22.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Fri Jan 15 2016 Orion Poplawski <orion@cora.nwra.com> 2.22.1-2
- Rebuild for osgi-resource-locator change

* Wed Oct 14 2015 gil cattaneo <puntogil@libero.it> 2.22.1-1
- update to 2.22.1

* Sun Oct 04 2015 gil cattaneo <puntogil@libero.it> 2.22-1
- update to 2.22

* Wed Aug 19 2015 gil cattaneo <puntogil@libero.it> 2.21-1
- update to 2.21

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.18-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Wed Jun 10 2015 gil cattaneo <puntogil@libero.it> 2.18-2
- built with new mimepull rhbz#1189216

* Tue Jun 09 2015 gil cattaneo <puntogil@libero.it> 2.18-1
- update to 2.18
- remove Obsolete duplicate declaration

* Sun Jun  7 2015 Peter Robinson <pbrobinson@fedoraproject.org> 2.17-4
- Obsolete jersey-contribs

* Fri May 29 2015 gil cattaneo <puntogil@libero.it> 2.17-3
- remove javax.el:el-api exclusions RHBZ#1223468

* Fri May 29 2015 gil cattaneo <puntogil@libero.it> 2.17-2
- generated apache-connector OSGi manifest

* Fri May 08 2015 gil cattaneo <puntogil@libero.it> 2.17-1
- update to 2.17

* Tue Jan 27 2015 gil cattaneo <puntogil@libero.it> 1.18.3-1
- update to 1.18.3
- introduce license macro

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.17.1-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Thu Jun 05 2014 gil cattaneo <puntogil@libero.it> 1.17.1-10
- fix javax.el apis

* Fri Mar 28 2014 Michael Simacek <msimacek@redhat.com> - 1.17.1-9
- Use Requires: java-headless rebuild (#1067528)

* Mon Nov 18 2013 gil cattaneo <puntogil@libero.it> 1.17.1-8
- use objectweb-asm3

* Tue Oct 15 2013 gil cattaneo <puntogil@libero.it> 1.17.1-7
- Do not install source jars

* Tue Oct 15 2013 gil cattaneo <puntogil@libero.it> 1.17.1-6
- fix for rhbz#1019234

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.17.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Wed Jul 10 2013 gil cattaneo <puntogil@libero.it> 1.17.1-4
- switch to XMvn
- minor changes to adapt to current guideline
- fix aId for new istack-commons maven plugin

* Sat Apr 27 2013 gil cattaneo <puntogil@libero.it> 1.17.1-3
- rebuilt with grizzly support

* Thu Mar 28 2013 gil cattaneo <puntogil@libero.it> 1.17.1-2
- fixed license field
- installed ASL license txt file

* Mon Mar 18 2013 gil cattaneo <puntogil@libero.it> 1.17.1-1
- update to 1.17.1

* Tue Jan 22 2013 gil cattaneo <puntogil@libero.it> 1.17-1
- update to 1.17

* Fri Jan 11 2013 gil cattaneo <puntogil@libero.it> 1.16-1
- update to 1.16

* Mon Nov 19 2012 gil cattaneo <puntogil@libero.it> 1.15-1
- update to 1.15

* Tue Sep 18 2012 gil cattaneo <puntogil@libero.it> 1.14-1
- update to 1.14

* Sat Jul 21 2012 gil cattaneo <puntogil@libero.it> 1.13-1
- update to 1.13

* Fri May 25 2012 gil cattaneo <puntogil@libero.it> 1.12-1
- initial rpm
